import { createApp } from 'vue'
import ToastMessage from './message.vue'
import vuetify from '@/plugins/vuetify'

var timeId
const toastMessage  = (options)  => {
  const rootNode = document.createElement("div")
  document.querySelector('.v-application').appendChild(rootNode)
  const app = createApp(ToastMessage, options)
  app.use(vuetify)
  app.mount(rootNode)
  const { timeout } = options || {}
  clearTimeout(timeId)
  timeId = setTimeout(() => {
      app.unmount()
      rootNode.remove()
  }, timeout || 3000)
}
toastMessage.success = (message, variant) => {
  toastMessage({ message, color: 'success', variant })
}
toastMessage.error = (message, variant) => {
  toastMessage({ message, color: 'error', variant })
}
toastMessage.info = (message, variant) => {
  toastMessage({ message, color: 'info', variant })
}
toastMessage.warning = (message, variant) => {
  toastMessage({ message, color: 'warning', variant })
}
// 注册插件app.use()会自动执行install函数
toastMessage.install = (app) => {
  app.config.globalProperties.Snackbar = toastMessage
}

export default toastMessage